

   MEMBER('ClarionTestTest.clw')                           ! This is a MEMBER module

                     MAP
                       INCLUDE('CLARIONTESTTEST002.INC'),ONCE        !Local module procedure declarations
                     END


Test_GetListOfExportedProceduresFromDLL PROCEDURE  (*long addr) ! Declare Procedure
!Tester                              ClarionTestManager
!ProcQ                               TestProcedureQueue
ProcQ                                                   QUEUE,pre()
ProcName                                                    string(255)
														end
DllName                                                 string(255)
DllMgr                                                  System_Runtime_Dll
  CODE
    addr = address(UnitTestResult)
    BeginUnitTest('Test_GetListOfExportedProceduresFromDLL')
    !-------------------------------------------------------------------
    ! Write your code to test for a result, using the AssertThat syntax.
    ! At present there are two different assertions you can use, IsEqualto
    ! and IsNotEqualTo. You can pass in any data type that Clarion can
    ! automatically convert to a string. 
    ! 
    ! 	AssertThat('a',IsEqualTo('a'),'this is an optional extra message')
    !	AssertThat(1,IsNotEqualTo(2))
    !
    ! As soon as an Assert statement fails there remaining tests will
    ! not be executed. 
    !-------------------------------------------------------------------
    
	dllname = longpath() & '\demodll\demodll.dll'
	!DllMgr.Init(dllname)
	r# = DllMgr.GetExportedProcedures(dllname,ProcQ)
	!message('Message before assert:' & GlobalTestResultInstance.Message)
	AssertThat(r#,IsEqualTo(Level:Benign),'Unable to open DemoDll ' & dllname & ', error ' & DllMgr.LastError)
	!message('Message after assert:' & GlobalTestResultInstance.Message)
	!DllMgr.Kill()

	!AssertThat(true,isequalto(False),'true does not equal false')
	!AssertThat(true,isequalto(true),'true equals true')
	
    return 0
Test_GetListOfExportedTestProceduresFromDLL PROCEDURE  (*long addr) ! Declare Procedure
ProcQ                                                   QUEUE,pre()
ProcName                                                    string(255)
														end
DllName                                                 string(255)
TestRunner                                                  ClarionTest_TestRunner
  CODE
    addr = address(UnitTestResult)
    BeginUnitTest('Test_GetListOfExportedTestProceduresFromDLL')
    !-------------------------------------------------------------------
    ! Write your code to test for a result, using the AssertThat syntax.
    ! At present there are two different assertions you can use, IsEqualto
    ! and IsNotEqualTo. You can pass in any data type that Clarion can
    ! automatically convert to a string. 
    ! 
    ! 	AssertThat('a',IsEqualTo('a'),'this is an optional extra message')
    !	AssertThat(1,IsNotEqualTo(2))
    !
    ! As soon as an Assert statement fails there remaining tests will
    ! not be executed. 
    !-------------------------------------------------------------------
    
	dllname = longpath() & '\demodll\demodll.dll'
	TestRunner.Init(dllname)
	TestRunner.GetTestProcedures(ProcQ)
	AssertThat(records(ProcQ),IsEqualTo(4),'Wrong number of procedures found in ' & dllname)
	get(procq,1)
	AssertThat(procq.procname,isequalto('Deliberate_Failure_For_Demo_Purposes'))
	get(procq,2)
	AssertThat(procq.procname,isequalto('Test_Group_Comparison'))
	get(procq,3)
	AssertThat(procq.procname,isequalto('Test_Integer_Comparison'))
	get(procq,4)
	AssertThat(procq.procname,isequalto('Test_String_Comparison'))
	TestRunner.Kill()
	
    return 0
Test_BasicLogic      PROCEDURE  (*long addr)               ! Declare Procedure

  CODE
    addr = address(UnitTestResult)
    BeginUnitTest('Test_BasicLogic')
    !-------------------------------------------------------------------
    ! Write your code to test for a result, using the AssertThat syntax.
    ! At present there are two different assertions you can use, IsEqualto
    ! and IsNotEqualTo. You can pass in any data type that Clarion can
    ! automatically convert to a string. 
    ! 
    ! 	AssertThat('a',IsEqualTo('a'),'this is an optional extra message')
    !	AssertThat(1,IsNotEqualTo(2))
    !
    ! As soon as an Assert statement fails there remaining tests will
    ! not be executed. 
    !-------------------------------------------------------------------
    
	AssertThat(1,IsNotEqualTo(2))	
	AssertThat('abc',IsNotEqualTo('ABC'))
	AssertThat('abc',IsEqualTo('abc'))
    return 0
Test_ExecuteTest     PROCEDURE  (*long addr)               ! Declare Procedure
ProcQ                       QUEUE,pre()
ProcName                        string(255)
							end
DllName                     string(255)
TestRunner                  ClarionTest_TestRunner
TestResult                  &ClarionTest_TestResult
  CODE
    addr = address(UnitTestResult)
    BeginUnitTest('Test_ExecuteTest')
    !-------------------------------------------------------------------
    ! Write your code to test for a result, using the AssertThat syntax.
    ! At present there are two different assertions you can use, IsEqualto
    ! and IsNotEqualTo. You can pass in any data type that Clarion can
    ! automatically convert to a string. 
    ! 
    ! 	AssertThat('a',IsEqualTo('a'),'this is an optional extra message')
    !	AssertThat(1,IsNotEqualTo(2))
    !
    ! As soon as an Assert statement fails there remaining tests will
    ! not be executed. 
    !-------------------------------------------------------------------
    
	dllname = longpath() & '\demodll\demodll.dll'
	TestRunner.Init(dllname)
	TestRunner.GetTestProcedures(ProcQ)
	AssertThat(records(ProcQ),IsNotEqualTo(0),'No tests found in ' & dllname)
	TestResult &= TestRunner.RunTest(1)
	if testresult &= null
		AssertThat(true,IsEqualTo(false),'Test result 1 was null')
	else
		AssertThat(TestResult.Passed,IsEqualTo(false),'Test 1 passed, expected fail - ' & TestResult.Message)
		AssertThat(TestResult.ProcedureName,IsEqualTo('Deliberate_Failure_For_Demo_Purposes'))
	end
	TestResult &= TestRunner.RunTest(2)
	if testresult &= null
		AssertThat(true,IsEqualTo(false),'Test 2 result was null')
	else
		AssertThat(TestResult.Passed,IsEqualTo(true),'Test 2 failed - ' & TestResult.Message)
		AssertThat(TestResult.ProcedureName,IsEqualTo('Test_Group_Comparison'))
	end
	TestRunner.Kill()
    return 0
