! This file contains various source needed by the ClarionTest
! unit testing framework.


	
	Section('GlobalData')
	include('ClarionTest_TestResult.inc'),once
	include('system_diagnostics_debugger.inc'),once

dbgr                System_Diagnostics_Debugger
UnitTestResult      ClarionTest_TestResult
UnitTestType        long
UnitTestVariableType        long
UnitTestExpectedString      &string
UnitTestExpectedLong        Long

	
	Section('GlobalMap')
!	MODULE('Winapi')
!		ODS(*CSTRING),PASCAL,RAW,NAME('OutputDebugStringA')                   !32-bit only
!	END
Debug               procedure(string s)
BeginUnitTest       Procedure(string testName)
AssertThat          procedure(string testResult,byte b,<string debugMessage>)
IsEqualTo           procedure(string expected),byte,proc
IsNotEqualTo        procedure(string expected),byte
IsNull              procedure(*? object),byte
SetUnitTestFailed   procedure(string stdMessage)
SetUnitTestFailed   procedure(string stdMessage,string userMessage)


	Section('ProgramProcedures')

Debug               procedure(string s)
	CODE
	dbgr.write('ClarionTest global code: ' & s)
	

BeginUnitTest       procedure(string testName)
	CODE
	clear(UnitTestResult)
	UnitTestResult.Passed = true
	UnitTestResult.ProcedureName = testName
	
AssertThat          procedure(string testResult,byte b,<string userMessage>)
Info                    cstring(1000)
	CODE
	debug('AssertThat(' & testresult & ',' & b & ')')
	debug('UnitTestType: ' & UnitTestType)
	debug('UnitTestExpectedString: ' & UnitTestExpectedString)
	if not omitted(userMessage)
		info = userMessage
	end
	if UnitTestResult.Passed = false then return.
!	if UnitTestVariableType <> UnitTestVariableTypes:StringType
!		SetUnitTestFailed('Strings can only be compared with other strings')
!	END
	if UnitTestExpectedString &= null
		SetUnitTestFailed('Expected string may not be null - use IsNull instead',info)
		return
	end
	case UnitTestType
	of UnitTestTypes:IsEqualTo
		debug('UnitTestTypes:IsEqualTo - comparing ' & clip(testResult) & ' with ' & clip(UnitTestExpectedString))
		if testResult <> UnitTestExpectedString
			SetUnitTestFailed('Expected ' & UnitTestExpectedString & ', received ' & testResult, info)
			RETURN
		END
	of UnitTestTypes:IsNotEqualTo
		debug('UnitTestTypes:IsEqualTo - comparing ' & clip(testResult) & ' with ' & clip(UnitTestExpectedString))
		if testResult = UnitTestExpectedString
			SetUnitTestFailed('Values are identical', info)
			RETURN
		END
	ELSE
		SetUnitTestFailed('Unknown test type')
	end
	return

IsEqualTo           procedure(string s)
	CODE
	UnitTestType = UnitTestTypes:IsEqualTo
	UnitTestVariableType = UnitTestVariableTypes:StringType
	UnitTestExpectedString &= new string(len(s))
	UnitTestExpectedString = s
	return true
	
IsNull           procedure(*? object)
	CODE
	if object &= null
		return true
	end
	return false
	

IsNotEqualTo        procedure(string s)
	CODE
	IsEqualTo(s)
	UnitTestType = UnitTestTypes:IsNotEqualTo
	return true
	
	
SetUnitTestFailed   procedure(string stdMessage)
	CODE
	SetUnitTestFailed(stdMessage,'')
	
SetUnitTestFailed   procedure(string stdMessage,string userMessage)
	CODE
	Debug('SetUnitTestFailed ' & stdMessage)
	UnitTestResult.Passed = false
	!UnitTestResult.Message = stdMessage & ' ' & userMessage
	UnitTestResult.Message = clip(userMessage) & ' (' & stdMessage & ')'
		
