
                    
					MEMBER()
					MAP
					end


	INCLUDE('System_IO_AsciiFile.inc'),ONCE
	include('System_Diagnostics_Debugger.inc'),once



AsciiFileNameA      STRING(MaxPathLength),static

AsciiFileA          FILE,DRIVER('ASCII','/CLIP = on'),CREATE,NAME(AsciiFileNameA),PRE(ASCIIA)
						RECORD
Txt                         STRING(ASCII_IO_RECORD_SIZE)
						END
					END

AsciiFileNameB      STRING(MaxPathLength),static

AsciiFileB          FILE,DRIVER('ASCII','/CLIP = on'),CREATE,NAME(AsciiFileNameB),PRE(ASCIIB)
						RECORD
Txt                         STRING(ASCII_IO_RECORD_SIZE)
						END
					END

AsciiFileNameC      STRING(MaxPathLength),static

AsciiFileC          FILE,DRIVER('ASCII','/CLIP = on'),CREATE,NAME(AsciiFileNameC),PRE(ASCIIC)
						RECORD
Txt                         STRING(ASCII_IO_RECORD_SIZE)
						END
					END


dbg                 System_Diagnostics_Debugger


System_IO_AsciiFile.Init     PROCEDURE(FILE AFile,*STRING FileLine,*STRING FName)
	CODE
	self.fileref &= aFile
	self.FileTxtRef &= FileLine
	self.FileNameRef &= fname
	
System_IO_AsciiFile.CloseFile    PROCEDURE()
	CODE
	!dbg.write('Closing ' & self.filenameref & ' from System_IO_AsciiFile.CloseFile')
	close(self.fileref)
	
System_IO_AsciiFile.OpenFile     PROCEDURE(STRING fname, LONG OpenMode=ReadWrite+DenyWrite)!, BYTE, PROC
	CODE
	RETURN SELF.Init(fName, False, OpenMode)

	
	
!-----------------------------------------------------------------------------------------
!InitFile
! For internal use only, by CreateFile & OpenFile
!-----------------------------------------------------------------------------------------
System_IO_AsciiFile.Init PROCEDURE(<STRING AsciiFileName>, BYTE CreateFile=False, LONG OpenMode=ReadWrite+DenyWrite)
	CODE
	dbg.SetPrefix('System_IO_AsciiFile.InitFile')
	if self.fileRef &= NULL
		!dbg.write('self.FileRef is null')
		return Level:Fatal
	end
	IF OMITTED(2)
		!dbg.Write('file name omitted, self.CurrentFileName = ' & self.currentfilename)
		IF STATUS(self.FileRef) = SELF.OpenMode AND NAME(self.FileRef) = SELF.CurrentFileName 
			!dbg.write('file is already open')
			RETURN LEVEL:Benign
		END
		OpenMode = SELF.OpenMode
	ELSE
		self.CurrentFileName = CLIP(AsciiFileName)
		!dbg.Write('self.CurrentFileName = ' & self.currentfilename)
	END
	self.FileNameRef = SELF.CurrentFileName
	IF STATUS(self.FileRef) 
		!dbg.write('closing ' & self.FileNameRef & ' from System_IO_AsciiFile.Init')
		CLOSE(self.FileRef)
	end
	IF CreateFile
		!dbg.write('creating file')
		LOOP 50 TIMES
			REMOVE(self.CurrentFileName)
			REMOVE(self.FileRef)
			CREATE(self.FileRef)
		WHILE ERRORCODE()
		IF ERRORCODE() THEN RETURN LEVEL:Notify.
	END
	LOOP 50 TIMES
		!dbg.write('trying to open ' & self.FileNameRef)
		OPEN(self.FileRef, OpenMode)
	WHILE ERRORCODE()
	IF ERRORCODE() 
		dbg.write('Error opening file: ' & error())
    !ASSERT(False, ERROR())
		RETURN LEVEL:Notify
	END
	IF ~OMITTED(2) 
		SELF.CurrentFileName      = NAME(self.FileRef)
		SELF.OpenMode      = STATUS(self.FileRef)
	END
	!dbg.write('file successfully opened')
	set(self.FileRef)
	RETURN LEVEL:Benign
	
System_IO_AsciiFile.Read     PROCEDURE(*CSTRING TextLine)!, BYTE, PROC	
	CODE
	if self.fileref &= null
		return Level:Fatal
	END
	next(self.fileref)
	if errorcode()
		return Level:Fatal
	end 
	TextLine = clip(self.FileTxtRef)
	return Level:Benign

System_IO_AsciiFile.IsOpen       PROCEDURE !,byte
	CODE
	IF STATUS(self.FileRef) = SELF.OpenMode AND NAME(self.FileRef) = SELF.CurrentFileName 
		return TRUE
	END
	return false

System_IO_AsciiFile.CreateFile       PROCEDURE(STRING AsciiFileName, LONG OpenMode=ReadWrite+DenyWrite)
	CODE
	RETURN SELF.Init(AsciiFileName, True, OpenMode)
	
System_IO_AsciiFile.Write    PROCEDURE(STRING TextLine)
ReturnValue                             BYTE(LEVEL:Benign)
	CODE
	IF ~SELF.FileNameRef THEN RETURN LEVEL:Fatal.
	IF SELF.AutoFlush
		SELF.Init()
	end
	self.FileTxtRef = CLIP(TextLine)
	ADD(self.FileRef)
	IF ERRORCODE() 
		ReturnValue = LEVEL:Notify
	END
	IF SELF.AutoFlush  
		CLOSE(self.FileRef)
		dbg.write('closing ' & self.FileNameRef & ' from System_IO_AsciiFile.Write (autoflush)')
	end
	RETURN ReturnValue	

System_IO_AsciiFile.GetName   PROCEDURE()
	CODE
	RETURN SELF.FileNameRef

System_IO_AsciiFile.Destruct  PROCEDURE()
	CODE
	SELF.CloseFile()

System_IO_AsciiFile.Replace                     procedure(string filename,queue q)	
txt	cstring(5000)
reccount	long
replace	byte
	code
	dbg.SetPrefix('System_IO_AsciiFile.Replace')
	if self.Init(filename) = Level:Benign
		dbg.write('Comparing queue to ' & filename)
		reccount = 0 
		replace = false
		loop while self.read(txt) = level:benign
			reccount += 1
			if reccount > records(q)
				dbg.write('more records in file than in queue')
				replace = TRUE
				BREAK
			END
			get(q,reccount)
			if q <> txt
				!dbg.write('text differs: ' & txt & ' <<> ' & q)
				replace = TRUE
				BREAK
			END
		end
		if reccount < records(q)
			dbg.write('more queue records than file records')
			replace = TRUE
		END
		if replace = TRUE
			dbg.write('replacing')
			
			self.closefile()
			if self.Init(filename,true) <> Level:Benign
				dbg.write('fatal error')
				return Level:Fatal
			end
			!dbg.write('Init succeeded')
			loop reccount = 1 to records(q)
				get(q,reccount)
				!dbg.write('trying to write ' & q)
				if self.write(clip(q)) <> level:benign
					!dbg.write('write failed')
					self.closefile()
					dbg.write('fatal error')
					return Level:Fatal
				end
			END
			dbg.write('closing file')
			self.closefile()
		end
		return level:benign
	ELSE
		return Level:Fatal
		dbg.write('fatal error')
	end

!System_IO_AsciiFileInstanceA.Init   PROCEDURE(STRING FName)
!	CODE
!	AsciiFileNameA = fname
!	self.Init(AsciiFileA,AsciifileA.Txt,AsciifileNameA)
	
System_IO_AsciiFileInstanceA.Construct   PROCEDURE
	CODE
	!dbg.write('firing System_IO_AsciiFileInstanceA.Construct')
	self.Init(AsciiFileA,AsciifileA.Txt,AsciifileNameA)
	
System_IO_AsciiFileInstanceB.Construct   PROCEDURE
	CODE
	!dbg.write('firing System_IO_AsciiFileInstanceA.Construct')
	self.Init(AsciiFileB,AsciifileB.Txt,AsciifileNameB)
									
System_IO_AsciiFileInstanceC.Construct   PROCEDURE
	CODE
	!dbg.write('firing System_IO_AsciiFileInstanceA.Construct')
	self.Init(AsciiFileC,AsciifileC.Txt,AsciifileNameC)
	


!System_IO_AsciiFileInstanceA.Construct      procedure()
!	code
!	self.Init(AsciiFileA,AsciiFileA:Txt, AsciiFileNameA)
!	
!
!
!
!
!System_IO_AsciiFile.OpenFile PROCEDURE(STRING fname, LONG OpenMode=ReadWrite+DenyWrite)!, BYTE, PROC
!result                                  long
!filename                                string(FILE:MaxFilePath)
!	CODE
!	filename = fname
!	dbg.SetPrefix('System_IO_AsciiFile.OpenFile')
!	dbg.Write(1)
!	dbg.write('filename: ' & filename)
!	if self.ErrorMgr &= null
!		dbg.write('ErrorMgr is null')
!	ELSE
!		dbg.write('ErrorMgr is not null')
!	end
!	if self.AsciiFile &= null
!		dbg.write('AsciiFile is null')
!	ELSE
!		dbg.write('AsciiFile is not null')
!	end
!	self.OpenMode = OpenMode
!	dbg.write('calling reset')
!	result = self.Reset(filename)
!	dbg.Write(2)
!	if result = Level:Benign
!		dbg.Write(3)
!		set(self.AsciiFile)
!	END
!	dbg.Write(4)
!	return result
!	
!
!System_IO_AsciiFile.CloseFile        PROCEDURE()
!	code
!	CLOSE(SELF.AsciiFile)
!!	
!System_IO_AsciiFile.Read     PROCEDURE(*CSTRING TextLine)!, BYTE, PROC
!	code
!	next(self.AsciiFile)
!	if errorcode()
!		return level:fatal
!	END
!	textline = self.AsciiTExt
!	return level:benign
!	
!
!
!
!System_IO_AsciiFile.Construct        PROCEDURE
!	CODE
!	self.ErrorMgr &= new ErrorClass()
!	
!System_IO_AsciiFile.Destruct procedure
!	CODE
!	dispose(self.ErrorMgr)
!	dispose(self.AsciiText)
!	
!	
!System_IO_AsciiFile.Init     PROCEDURE(FILE f,*STRING FileLine,*STRING FName)
!	CODE
!	self.AsciiText &= FileLine
!	self.Init(f,FileLine,FName,self.ErrorMgr)
!	
!
!System_IO_AsciiFile.Reset        PROCEDURE(*STRING FName)
!
!RVal                            BYTE(False)
!SavePath                        CSTRING(FILE:MaxFilePath+1),AUTO
!
!	CODE
!	dbg.SetPrefix('System_IO_AsciiFile.Reset')
!	dbg.write(1)
!	CLOSE(SELF.AsciiFile)
!	dbg.write(2)
!	!FREE(SELF.IndexQueue)
!	SavePath=PATH()
!	LOOP
!		dbg.write(3)
!		OPEN(SELF.AsciiFile,SELF.OpenMode)
!		IF ERRORCODE()
!			dbg.write(5)
!			IF ~INLIST(SELF.ErrorMgr.Throw(Msg:FileLoadFailed),Level:Benign,Level:User) THEN BREAK.
!		ELSE
!			RVal=True
!		END
!	UNTIL RVal=True
!	dbg.write(5.5)
!	IF RVal
!		dbg.write(6)
!		SELF.FileSize=BYTES(SELF.AsciiFile)
!		dbg.write(7)
!		SELF.ErrorMgr.SetFile(NAME(SELF.AsciiFile))
!		dbg.write(8)
!	END
!	dbg.write(9)
!	SETPATH(SavePath)
!	dbg.write(10)
!	RETURN RVal
!	
!
!!System_IO_AsciiFileInstanceA.OpenFile       PROCEDURE(STRING AsciiFileName, LONG OpenMode=ReadWrite+DenyWrite)!, BYTE, PROC	
!!	code
!
!
!
!
!!InputFileName CSTRING(FILE:MaxFilePath+FILE:MaxFileName+1)
!!InputFile     FILE,DRIVER('ASCII'),CREATE,NAME(InputFileName),PRE(AsciiFile)
!!						RECORD
!!Txt                         STRING(ASCII_IO_RECORD_SIZE)
!!						END
!!					END
!!
!!OutputFileName      CSTRING(FILE:MaxFilePath+FILE:MaxFileName+1)
!!OutputFile     FILE,DRIVER('ASCII'),CREATE,NAME(InputFileName),PRE(AsciiFile)
!!						RECORD
!!Txt                         STRING(ASCII_IO_RECORD_SIZE)
!!						END
!!					END
!!
!!dbg                 System_Diagnostics_Debugger
!!
!!
!!!-----------------------------------------------------------------------------------------
!!!Write
!!! Writes a line of text specified by TextLine to the end of the file
!!!-----------------------------------------------------------------------------------------
!!System_IO_AsciiFile.WriteOutput   PROCEDURE(STRING TextLine)
!!ReturnValue                     BYTE(LEVEL:Benign)
!!	CODE
!!	IF ~SELF.OutputFileName THEN RETURN LEVEL:Fatal.
!!	SELF.InitOutputFile()
!!	OutputFile.Txt = CLIP(TextLine)
!!	!dbg.write(self.GetOutputName() & ' writing ' & TextLine)
!!	ADD(OutpFile)
!!	IF ERRORCODE() 
!!    !ASSERT(False, ERROR())
!!		ReturnValue = LEVEL:Notify
!!	END
!!	IF SELF.AutoFlush THEN CLOSE(OutputFile).
!!	RETURN ReturnValue
!!
!!System_IO_AsciiFile.OpenInputFile        PROCEDURE(STRING AsciiFileName, LONG OpenMode=ReadWrite+DenyWrite)
!!	CODE
!!	RETURN SELF.InitInputFile(AsciiFileName, False, OpenMode)
!!
!!System_IO_AsciiFile.OpenOutputFile   PROCEDURE(STRING AsciiFileName, LONG OpenMode=ReadWrite+DenyWrite)
!!	CODE
!!	RETURN SELF.InitOutputFile(AsciiFileName, False, OpenMode)
!!
!!
!!System_IO_AsciiFile.InitInputFile        PROCEDURE(<STRING AsciiFileName>, BYTE CreateFile=False, LONG OpenMode=ReadWrite+DenyWrite)
!!	CODE
!!	dbg.SetPrefix('System_IO_AsciiFile.InitOutputFile')
!!	!dbg.write('start of method')
!!	IF OMITTED(2)
!!		IF STATUS(InputFile) = SELF.OpenMode AND NAME(InputFile) = SELF.InputFileName 
!!			RETURN LEVEL:Benign
!!		END
!!		InputFileName = SELF.InputFileName
!!		OpenMode = SELF.OpenMode
!!	ELSE
!!		InputFileName = CLIP(AsciiFileName)
!!	END
!!	IF STATUS(InputFile) THEN CLOSE(InputFile).
!!	IF CreateFile
!!		LOOP 50 TIMES
!!			REMOVE(InputFileName)
!!			REMOVE(InputFile)
!!			CREATE(InputFile)
!!		WHILE ERRORCODE()
!!		IF ERRORCODE() THEN RETURN LEVEL:Notify.
!!	END
!!	LOOP 50 TIMES
!!		OPEN(InputFile, OpenMode)
!!	WHILE ERRORCODE()
!!	IF ERRORCODE() 
!!		!dbg.write('error opening ' & InputFileName & ' ' & error())
!!    !ASSERT(False, ERROR())
!!		RETURN LEVEL:Notify
!!	END
!!	!dbg.write('File successfully opened')
!!	IF ~OMITTED(2) 
!!		SELF.FileName      = NAME(InputFile)
!!		SELF.OpenMode      = STATUS(InputFile)
!!	END
!!	dbg.write('Issuing SET(InputFile) - name ' & name(InputFile))
!!	set(InputFile)
!!	if errorcode()
!!		!dbg.write('Error on SET: ' & error())
!!		return Level:Fatal
!!	end
!!
!!	RETURN LEVEL:Benign
!!	
!!System_IO_AsciiFile.InitOutputFile        PROCEDURE(<STRING AsciiFileName>, BYTE CreateFile=False, LONG OpenMode=ReadWrite+DenyWrite)
!!	CODE
!!	dbg.SetPrefix('System_IO_AsciiFile.InitOutputFile')
!!	!dbg.write('start of method')
!!	IF OMITTED(2)
!!		IF STATUS(OutputFile) = SELF.OpenMode AND NAME(OutputFile) = SELF.OutputFileName 
!!			RETURN LEVEL:Benign
!!		END
!!		OutputFileName = SELF.OutputFileName
!!		OpenMode = SELF.OpenMode
!!	ELSE
!!		OutputFileName = CLIP(AsciiFileName)
!!	END
!!	IF STATUS(OutputFile) THEN CLOSE(OutputFile).
!!	IF CreateFile
!!		LOOP 50 TIMES
!!			REMOVE(OutputFileName)
!!			REMOVE(OutputFile)
!!			CREATE(OutputFile)
!!		WHILE ERRORCODE()
!!		IF ERRORCODE() THEN RETURN LEVEL:Notify.
!!	END
!!	LOOP 50 TIMES
!!		OPEN(OutputFile, OpenMode)
!!	WHILE ERRORCODE()
!!	IF ERRORCODE() 
!!		!dbg.write('error opening ' & OutputFileName & ' ' & error())
!!    !ASSERT(False, ERROR())
!!		RETURN LEVEL:Notify
!!	END
!!	!dbg.write('File successfully opened')
!!	IF ~OMITTED(2) 
!!		SELF.FileName      = NAME(OutputFile)
!!		SELF.OpenMode      = STATUS(OutputFile)
!!	END
!!	dbg.write('Issuing SET(OutputFile) - name ' & name(OutputFile))
!!	set(OutputFile)
!!	if errorcode()
!!		!dbg.write('Error on SET: ' & error())
!!		return Level:Fatal
!!	end
!!
!!	RETURN LEVEL:Benign
!!
!!!!-----------------------------------------------------------------------------------------
!!!!Read
!!!! Reads a line of text into the string buffer specified by TextLine
!!!! If no specific text file position is specified then the next file line in sequence 
!!!! is retrieved.
!!!!-----------------------------------------------------------------------------------------
!!System_IO_AsciiFile.ReadInput    PROCEDURE(*CSTRING TextLine)
!!NullPtrCheck                    &CSTRING
!!	CODE
!!	!dbg.SetPrefix('System_IO_AsciiFile.Read')
!!	!dbg.Write('Start of method')
!!	IF ~SELF.FileName THEN RETURN LEVEL:Fatal.
!!	NullPtrCheck &= TextLine
!!	IF  NullPtrCheck &= NULL THEN RETURN LEVEL:Fatal.
!!
!!	SELF.InitFile()
!! 	!dbg.write('next(InputFile)')
!!	next(InputFile)
!!	IF ERRORCODE() 
!!		!dbg.Write('error: ' & error())	
!!		RETURN LEVEL:Notify
!!	end
!!	TextLine = InputFile.Txt
!!	!dbg.write(self.GetName() & ' ' & textline)
!!	RETURN LEVEL:Benign
!!
!!!-----------------------------------------------------------------------------------------
!!!IsOpen
!!! Returns a boolean indication of whether or not the file is open
!!!-----------------------------------------------------------------------------------------
!!System_IO_AsciiFile.IsOpen  PROCEDURE()
!!	CODE
!!
!!	IF ~SELF.FileName 
!!		RETURN False
!!	ELSE
!!		RETURN True
!!	END
!!!
!!!! First off link the appropriate ASCII file driver that will be required to link successfully...
!!!
!!! COMPILE('DLL ?',Dll_Mode)          ! First we need a Dll_Mode negated symbol
!!!_ABCLibMode_ EQUATE(False)          ! for the LINK attributes that follow below
!!! DLL ?
!!! OMIT('LIB ?',Dll_Mode)
!!!_ABCLibMode_ EQUATE(True)
!!! LIB ?
!!!
!!!  
!!!-----------------------------------------------------------------------------------------
!!!CreateFile
!!! Initialize the class by creating a new (or truncating an existing) file to operate on
!!!-----------------------------------------------------------------------------------------
!!System_IO_AsciiFile.CreateFile      PROCEDURE(STRING AsciiFileName, LONG OpenMode=ReadWrite+DenyWrite)
!!	CODE
!!
!!	RETURN SELF.InitFile(AsciiFileName, True, OpenMode)
!!
!!!
!!!-----------------------------------------------------------------------------------------
!!!OpenFile
!!! Initialize the class by opening an existing file to operate on
!!!-----------------------------------------------------------------------------------------
!!!
!!!
!!!!-----------------------------------------------------------------------------------------
!!!!OpenOrCreateFile
!!!! Initialize the class by opening an existing file or alternatively creating a new file 
!!!! when the file does not exist
!!!!-----------------------------------------------------------------------------------------
!!!System_IO_AsciiFile.OpenOrCreateFile  PROCEDURE(STRING AsciiFileName, LONG OpenMode=ReadWrite+DenyWrite)
!!! CODE
!!!
!!! IF EXISTS(AsciiFileName)
!!!    RETURN SELF.InitFile(AsciiFileName, False, OpenMode)
!!! ELSE
!!!    RETURN SELF.InitFile(AsciiFileName, True, OpenMode)
!!! END
!!!
!!!
!!!-----------------------------------------------------------------------------------------
!!!GetName
!!! Returns the current file name of the file being operated on
!!!-----------------------------------------------------------------------------------------
!!System_IO_AsciiFile.GetName PROCEDURE()
!!	CODE
!!
!!	RETURN SELF.FileName
!!
!!!
!!!
!!!
!!!System_IO_AsciiFile.Read              PROCEDURE(*STRING TextLine, <ULONG ReadPosition>)
!!!NullPtrCheck                        &STRING
!!!cTextLine                           CSTRING(ASCII_IO_RECORD_SIZE+1),AUTO
!!!ReturnValue                         BYTE,AUTO
!!! CODE
!!!
!!! IF ~SELF.FileName THEN RETURN LEVEL:Fatal.
!!! NullPtrCheck &= TextLine
!!! IF  NullPtrCheck &= NULL THEN RETURN LEVEL:Fatal.
!!!
!!! IF OMITTED(3) 
!!!    ReturnValue = SELF.Read(cTextLine)
!!! ELSE
!!!    ReturnValue = SELF.Read(cTextLine, ReadPosition)
!!! END
!!!
!!! TextLine = cTextLine
!!!
!!! RETURN ReturnValue
!!!
!!!
!!!System_IO_AsciiFile.Read              PROCEDURE(*PSTRING TextLine, <ULONG ReadPosition>)
!!!NullPtrCheck                        &PSTRING
!!!cTextLine                           CSTRING(ASCII_IO_RECORD_SIZE+1),AUTO
!!!ReturnValue                         BYTE,AUTO
!!! CODE
!!!
!!! IF ~SELF.FileName THEN RETURN LEVEL:Fatal.
!!! NullPtrCheck &= TextLine
!!! IF  NullPtrCheck &= NULL THEN RETURN LEVEL:Fatal.
!!!
!!! IF OMITTED(3) 
!!!    ReturnValue = SELF.Read(cTextLine)
!!! ELSE
!!!    ReturnValue = SELF.Read(cTextLine, ReadPosition)
!!! END
!!!
!!! TextLine = cTextLine
!!!
!!! RETURN ReturnValue
!!!
!!!
!!!!-----------------------------------------------------------------------------------------
!!!!Replace
!!!! Replaces the previously read line of text with the text specified by TextLine
!!!!-----------------------------------------------------------------------------------------
!!!System_IO_AsciiFile.Replace           PROCEDURE(STRING TextLine)
!!!ReturnValue                         BYTE(LEVEL:Benign)
!!! CODE
!!!
!!! IF ~SELF.FileName THEN RETURN LEVEL:Fatal.
!!! IF ~SELF.PreviousReadPosition THEN RETURN LEVEL:Notify.
!!!
!!! SELF.InitFile()
!!!
!!! GET(InputFile, SELF.PreviousReadPosition)
!!!
!!! IF LEN(CLIP(TextLine)) >= LEN(CLIP(InputFile:TextLine))
!!!    InputFile:TextLine = SUB(TextLine, 1, LEN(CLIP(InputFile:TextLine)))
!!! ELSE
!!!    InputFile:TextLine = SUB(TextLine & ALL(' ', ASCII_IO_RECORD_SIZE), 1, |
!!!                            LEN(CLIP(InputFile:TextLine))-1) & CHR(0)
!!! END
!!! PUT(InputFile)
!!! IF ERRORCODE() 
!!!    ReturnValue = LEVEL:Notify
!!! END
!!!
!!! IF SELF.AutoFlush THEN CLOSE(InputFile).
!!!
!!! RETURN ReturnValue
!!!
!!!
!!!
!!!
!!!
!!!
!!!!-----------------------------------------------------------------------------------------
!!!!GetReadPosition
!!!! Returns the current text file position in the read sequence
!!!! (This is the position that will be read from by the read functions when no position
!!!! is explicitly specified)
!!!!-----------------------------------------------------------------------------------------
!!!System_IO_AsciiFile.GetReadPosition   PROCEDURE()
!!! CODE
!!!
!!! IF ~SELF.FileName 
!!!    RETURN False
!!! ELSE
!!!    RETURN SELF.ReadPosition
!!! END
!!!
!!!
!!!!-----------------------------------------------------------------------------------------
!!!!SetReadPosition
!!!! Sets/Resets the current text file position in the read sequence
!!!! (Sets the position that will be read from by the read functions when no position
!!!! is explicitly specified)
!!!!-----------------------------------------------------------------------------------------
!!!System_IO_AsciiFile.SetReadPosition   PROCEDURE(ULONG ReadPosition)
!!! CODE
!!!
!!! IF ~SELF.FileName 
!!!    RETURN
!!! ELSE
!!!    SELF.ReadPosition = ReadPosition
!!! END
!!!
!!!
!!!!-----------------------------------------------------------------------------------------
!!!!GetWritePosition
!!!! Returns the current text file position in the write sequence
!!!! (This is the position that will be written to by the write functions, i.e. the number of
!!!! bytes in the file + 1)
!!!!-----------------------------------------------------------------------------------------
!!!System_IO_AsciiFile.GetWritePosition  PROCEDURE()
!!!WritePosition                       ULONG(1)
!!! CODE
!!!
!!! IF ~SELF.FileName THEN RETURN False.
!!!
!!! SELF.InitFile()
!!!
!!! SET(InputFile)
!!! LOOP 
!!!    NEXT(InputFile)
!!!    IF ERRORCODE() THEN BREAK.
!!!    WritePosition = POINTER(InputFile) + BYTES(InputFile)
!!! END
!!!
!!! RETURN WritePosition
!!!
!!!
!!!!-----------------------------------------------------------------------------------------
!!!!CloseFile
!!!! Closes the file being operated on
!!!!-----------------------------------------------------------------------------------------
!!System_IO_AsciiFile.CloseFile       PROCEDURE()
!!	CODE
!!	IF ~SELF.FileName THEN RETURN.
!!	CLOSE(InputFile)
!!	CLEAR(SELF.Filename)
!!
!!!
!!!!-----------------------------------------------------------------------------------------
!!!!SetAutoFlush
!!!! Sets "Auto Flush" behaviour. When "Auto Flush" is enabled the file is closed after each 
!!!! disk write to force "flushing" the file. While this behaviour causes slower file I/O it
!!!! may be desirable for logging and situates where a partially written file because of a 
!!!! program crash is desirable, etc.
!!!!-----------------------------------------------------------------------------------------
!!!System_IO_AsciiFile.SetAutoFlush      PROCEDURE(BYTE AutoFlush)
!!! CODE
!!!
!!! SELF.AutoFlush = AutoFlush
!!!
!!!
!!!-----------------------------------------------------------------------------------------
!!!InitFile
!!! For internal use only, by CreateFile & OpenFile
!!!-----------------------------------------------------------------------------------------
!!!
!!!
!!!-----------------------------------------------------------------------------------------
!!!Destruct
!!! Automatic destructor to ensure the file is closed properly 
!!!-----------------------------------------------------------------------------------------
!!System_IO_AsciiFile.Destruct          PROCEDURE
!! CODE
!!
!! SELF.CloseInputFile()
!!SELF.CloseOutputFile()
!!
!!
