                    Member()
  Include('Equates.CLW'),ONCE
  Include('Keycodes.CLW'),ONCE
  Include('Errors.CLW'),ONCE
  Include('System_IO_CaptureStdOutput.inc'),ONCE
  !------------------------------------------------------------------------------
System_IO_CaptureStdOutput.ErrorHandler   PROCEDURE  (<STRING pErrorMsg>)  ! Declare Procedure 3
lErrMsg                       CSTRING(512)
VA_List                       CSTRING(20)
  CODE
    SELF.ErrMsg = ''
    IF OMITTED(2)
      Self.ErrorCode = api_GetLastError()
      IF api_FormatMessage(BOR(BOR(api_FORMAT_MESSAGE_FROM_SYSTEM,api_FORMAT_MESSAGE_IGNORE_INSERTS),api_FORMAT_MESSAGE_MAX_WIDTH_MASK)|
        , 0, Self.ErrorCode, api_LANG_USER_DEFAULT, lErrMsg, SIZE(lErrMsg), VA_List)
        Self.ErrMsg = lErrMsg
      ELSE
        SELF.ErrMsg = 'An unknown error has occurred.'
      END
    ELSE
      SELF.ErrMsg = CLIP(LEFT(pErrorMsg))
    END

    IF Self.SupressErrors
      Self.DebugOutput('------- error Create Process: ' & SELF.ErrMsg)
    ELSE
      MESSAGE('An error has occurred while attempting to create the requested process.' & |
        '|Error posted: ' & SELF.ErrMsg, |
        'Error creating process', ICON:Hand)
    END
System_IO_CaptureStdOutput.DebugOutput  PROCEDURE  (STRING pDebugString) 
lCString              &CSTRING
  CODE
    lCString &= NEW CSTRING(LEN(CLIP(pDebugString)) + 3)
    lCString = CLIP(pDebugString) & '<13,10,0>'
    api_OutPutDebugString(lCString)
    DISPOSE(lCString)
  !------------------------------------------------------------------------------
System_IO_CaptureStdOutput.CreateProcessCaptureOutput PROCEDURE  (STRING pExecCmd, USHORT pExecMode, BYTE pUseCMD=1, <STRING pPath>, <STRING pMessage>, <STRING pTitle>, <*LONG pExitCommand>, <*System_String pResults>) !,LONG,PROC ! Declare Procedure 3
WindowOpened                              BYTE
CommandPrefix                             CSTRING(132)                          ! either CMD.EXE /C or COMMAND.COM /C depening upon platform
ProcessID                                 LONG                                  !
RetVal                                    BYTE                                  !
rVal                                      LONG
ExecCmdWinCommand                         &CSTRING
ExecCmdWinExecMode                        USHORT
procPath                                  CSTRING(File:MaxFilePath)
lEnvironStr                               CSTRING(256),AUTO
ExecWindow                                WINDOW('Execute Command'),AT(,,302,117),FONT('MS Sans Serif',10,,FONT:regular),CENTER,IMM, |
                                            CURSOR(CURSOR:Wait),TIMER(10),GRAY,DOUBLE
                                            STRING('Executing Command...'),AT(44,11,213,10),USE(?Message),CENTER
                                            TEXT,AT(2,23,297,89),USE(?OutputText),BOXED,HVSCROLL,READONLY
                                          END
ExecCmdwCreateFlags                       api_DWORD
ExecCmdExitCode                           api_DWORD
ExecCmdApplicationName                    CSTRING(255)
ExecCmdStartupInfo                        LIKE(api_StartupInfo)
ExecCmdProcessInformation                 LIKE(api_ProcessInformation)
StdOutRedirectFile                        CSTRING(100)
StdErrRedirectFile                        CSTRING(100)
stdOutsa                                  LIKE(api_SECURITY_ATTRIBUTES)
stdErrsa                                  LIKE(api_SECURITY_ATTRIBUTES)
stdoldOut                                 api_HANDLE
stdoldErr                                 api_HANDLE
lNoFree                                   BYTE
                                          !Pipe Stuff
hChildStdoutRd                            api_HANDLE
hChildStdErrWr                            api_HANDLE
hChildStdoutWr                            api_HANDLE
hChildStdInWr                             api_HANDLE
duphChildStdoutRd                         api_HANDLE
hProc                                     api_HANDLE
saAttr                                    LIKE(api_SECURITY_ATTRIBUTES)
chBuf                                     CSTRING(4096)
BUFSIZE                                   LONG(SIZE(chBuf))
dwRead                                    LONG
lResults                                  System_String
hConsoleWin                               api_HWND

  CODE
    RetVal = FALSE
    lEnvironStr = 'COMSPEC'
    CommandPrefix = api_GetEnvironment(lEnvironStr)
    CommandPrefix = CommandPrefix & ' /C '

    ExecCmdWinCommand          &= NEW(CSTRING(LEN(CommandPrefix & pExecCmd)+1))
    ExecCmdWinCommand          = CHOOSE(pUseCMD,CommandPrefix,'') & pExecCmd
    ExecCmdWinExecMode         = pExecMode
    ExecCmdwCreateFlags        = api_CREATE_DEFAULT_ERROR_MODE + api_NORMAL_PRIORITY_CLASS
    ExecCmdStartupInfo.cb      = SIZE(ExecCmdStartupInfo)
    ExecCmdStartupInfo.dwFlags = api_STARTF_USESHOWWINDOW + api_STARTF_USESTDHANDLES

    hProc = api_GetCurrentProcess()
    CLEAR(saAttr)
    saAttr.bInheritHandle = TRUE
    saAttr.nLength = SIZE(saAttr)
    !create our pipe to capture the process output
    IF NOT api_CreatePipe(ADDRESS(hChildStdoutRd), |
                          ADDRESS(hChildStdoutWr), |
                          ADDRESS(saAttr), |
                          0)
      Self.ErrorHandler()
      DO CleanupAndReturn
    END

    !create an inheritable duplicate handle to the pipe to use for the stdErr value
    IF NOT api_DuplicateHandle(hProc, |
                                hChildStdoutWr, |
                                hProc, |
                                ADDRESS(hChildStdErrWr), |
                                0, |
                                TRUE, |
                                api_DUPLICATE_SAME_ACCESS)
      Self.ErrorHandler()
      DO CleanupAndReturn
    END
    !create a NON inheritable duplicate handle to the pipe to use in this process for reading the pipe
    IF NOT api_DuplicateHandle(hProc, |
                                hChildStdoutRd, |
                                hProc,|
                                ADDRESS(duphChildStdoutRd), |! Address of new handle.
                                0, |
                                FALSE,             |! Make it uninheritable.
                                api_DUPLICATE_SAME_ACCESS)
      Self.ErrorHandler()
      DO CleanupAndReturn
    END
    ! close the Child read end of the pipe for stdout and stderr. The child process will only write to the pipe.
    IF NOT api_CloseHandle(hChildStdoutRd)
      Self.ErrorHandler()
      DO CleanupAndReturn
    Else
      Clear(hChildStdoutRd)
    END
    !
    !Set the process startup info handles to the new write handle for our pipe
    ExecCmdStartupInfo.hStdOutput = hChildStdoutWr
    ExecCmdStartupInfo.hStdError  = hChildStdErrWr

    SETCURSOR(CURSOR:Wait)
    IF NOT OMITTED(pPath)
      procPath = pPath
      ProcessID = api_CreateProcess(0,|
                                    ADDRESS(ExecCmdWinCommand),|
                                    0,|
                                    0,|
                                    true,|
                                    ExecCmdwCreateFlags, |
                                    0,|
                                    ADDRESS(procPath),|
                                    ADDRESS(ExecCmdStartupInfo),|
                                    ADDRESS(ExecCmdProcessInformation))
    ELSE
      ProcessID = api_CreateProcess(0, |
                                    ADDRESS(ExecCmdWinCommand),|
                                    0,|
                                    0,|
                                    true,|
                                    ExecCmdwCreateFlags, |
                                    0,|
                                    0,|
                                    ADDRESS(ExecCmdStartupInfo),|
                                    ADDRESS(ExecCmdProcessInformation))
    END
    !You need to close the write end of the pipes in THIS process before trying to
    !read from the read end of the pipe. If you don't do this then api_ReadFile will hang.
    !The child process already has handles to the pipe after CreateProcess so you don't have to worry.
    IF NOT api_CloseHandle(hChildStdoutWr)
      Self.ErrorHandler()
      DO CleanupAndReturn
    Else
      Clear(hChildStdoutWr)
    END
    IF NOT api_CloseHandle(hChildStdErrWr)
      Self.ErrorHandler()
      DO CleanupAndReturn
    Else
      Clear(hChildStdErrWr)
    END
    IF ProcessID
      OPEN(ExecWindow)
      WindowOpened=True
      IF NOT pTitle AND NOT pMessage
        ExecWindow{PROP:Hide} = True
      ELSE
        ExecWindow{PROP:Text} = CLIP(pTitle)
        ?Message{PROP:Text}   = CLIP(pMessage)
      END
      ACCEPT
        CASE EVENT()
        OF Event:Timer
          rVal = api_ReadFile( duphChildStdoutRd, ADDRESS(chBuf), BUFSIZE, ADDRESS(dwRead), 0)
          IF NOT rVal OR dwRead = 0
            IF NOT rVal AND api_GetLastError() <> api_ERROR_BROKEN_PIPE
              Self.ErrorHandler()
              lResults.Assign(CLIP(Self.ErrMsg))
            END
            0{prop:Timer} = 0
            BREAK
          END
          chBuf[dwRead+1] = '<00>'
          lResults.Append(chBuf)
          ?OutputText{Prop:Text} = ?OutputText{Prop:Text} & chBuf
          ?OutputText{prop:Vscrollpos} = 255
          DISPLAY(?OutputText)
        END
      END
      rVal = api_GetExitCodeProcess(ExecCmdProcessInformation.hProcess, ADDRESS(ExecCmdExitCode))
      IF NOT OMITTED(pExitCommand)
        pExitCommand = ExecCmdExitCode
      END
      retVal = true
    ELSE
      Self.ErrorHandler()
      lResults.Assign(CLIP(Self.ErrMsg))
      retVal = False
    END
    SETCURSOR()
    !
    DO CleanupAndReturn

  !---------------------------------------------------------------------------
CleanupAndReturn    ROUTINE
  
  If hChildStdoutRd
    R# = api_CloseHandle(hChildStdoutRd)
  End
  If hChildStdoutWr
    R# = api_CloseHandle(hChildStdoutWr)
  End
  If duphChildStdoutRd
    R# = api_CloseHandle(duphChildStdoutRd)
  End
  IF ExecCmdProcessInformation.hProcess AND ExecCmdProcessInformation.hProcess <> api_INVALID_LONG_VALUE
    R# = api_CloseHandle(ExecCmdProcessInformation.hProcess)
  END
  IF ExecCmdProcessInformation.hThread AND ExecCmdProcessInformation.hThread <> api_INVALID_LONG_VALUE
    R# = api_CloseHandle(ExecCmdProcessInformation.hThread)
  END
  IF NOT ExecCmdWinCommand &= NULL
    DISPOSE(ExecCmdWinCommand)
  END
  IF NOT OMITTED(pResults)
    pResults.Assign(lResults.Get())
  END
  IF WindowOpened
    CLOSE(ExecWindow)
  END
  Return RetVal


