					member()


					MAP
						include('cwutil.inc')
						MODULE('Windows.lib')
							SHFileOperation(LONG pSHFILEOPgroup), LONG, PASCAL,RAW, DLL,NAME('SHFileOperationA')
						END
					END

	include('System_IO_Directory.inc'),once
	include('System_Diagnostics_Debugger.inc')
!
! Shell File Operations
!
FO_MOVE             EQUATE(0001h)
FO_COPY             EQUATE(0002h)
FO_DELETE           EQUATE(0003h)
FO_RENAME           EQUATE(0004h)

FOF_MULTIDESTFILES  EQUATE(0001h)
FOF_CONFIRMMOUSE    EQUATE(0002h)
FOF_SILENT          EQUATE(0004h)  ! don't create progress/report
FOF_RENAMEONCOLLISION       EQUATE(0008h)
FOF_NOCONFIRMATION  EQUATE(0010h)  ! Don't prompt the user.

! Fill in SHFILEOPSTRUCT.hNameMappings
! Must be freed using SHFreeNameMappings
FOF_WANTMAPPINGHANDLE       EQUATE(0020h)
FOF_ALLOWUNDO       EQUATE(0040h)
FOF_FILESONLY       EQUATE(0080h)  ! on *.*, do only files
FOF_SIMPLEPROGRESS  EQUATE(0100h)  ! means don't show names of files
! don't confirm making any needed dirs
FOF_NOCONFIRMMKDIR  EQUATE(0200h)
FOF_NOERRORUI       EQUATE(0400h)  ! don't put up error UI
! dont copy NT file Security Attributes
FOF_NOCOPYSECURITYATTRIBS   EQUATE(0800h)
FOF_NORECURSION     EQUATE(1000h)  ! don't recurse into directories.
! don't operate on connected elements.
FOF_NO_CONNECTED_ELEMENTS   EQUATE(2000h)
! during delete operation, warn if nuking instead of recycling
! (partially overrides FOF_NOCONFIRMATION)
FOF_WANTNUKEWARNING EQUATE(4000h)

SHFILEOPgroup       GROUP, TYPE
hwnd                    UNSIGNED
wFunc                   UNSIGNED
pFrom                   LONG
pTo                     LONG
fFlags                  USHORT
fAnyOperationsAborted   LONG
hNameMappings           LONG
lpszProgressTitle       LONG
					END


dbg                 System_Diagnostics_Debugger

SHFileOp            LIKE(SHFILEOPgroup)
Source              CSTRING(256)
Destination         CSTRING(256)

	
System_IO_Directory.Construct       procedure
	code
	dbg.SetPrefix('System_IO_Directory')
	self.fileq &= new System_IO_FileInfoQueue
	
System_IO_Directory.Destruct        procedure
	code
	free(self.fileq)
	dispose(self.fileq)
	
	
	
System_IO_Directory.FileCount       procedure !,long
	CODE
	if self.RefreshNeeded
		self.GetDirectoryListing()
	END
	return records(self.FileQ)
	
System_IO_Directory.GetDirectoryListing     procedure	
Files                                           QUEUE(File:queue),PRE(FIL)    !Inherit exact declaration of File:queue
												END
x                                               long
	CODE
	loop x = 1 to records(self.fileq)
		get(self.fileq,x)
		dispose(self.fileq.System_IO_FileInfo)
	END
	free(self.fileq)
	dbg.Write('Looking in path ' & self.Path & self.Filter)
	DIRECTORY(Files,self.Path & self.Filter, ff_:Normal)  
	dbg.Write(records(files) & ' directory items found')
	loop x = 1 to records(Files)
		get(Files,x)
		if (self.MaxDaysOld > 0)
			if files.Date < today() and (files.Date + self.MaxDaysOld) < today()
				CYCLE
			end
		end
		clear(self.fileq)
		self.fileq.System_IO_FileInfo &= new System_IO_FileInfo()
		self.fileq.System_IO_FileInfo.FileName = files.Name
		!dbg.Write('added self.fileq.System_IO_FileInfo.filename ' & self.fileq.System_IO_FileInfo.FileName)
		add(self.fileq)
	end
	
System_IO_Directory.LoadFilenamesQueue      procedure(*System_IO_DirectoryQueue q)
x                                               long
	CODE
	if self.RefreshNeeded
		self.GetDirectoryListing()
	END
	loop x = 1 to records(self.FileQ)
		get(self.fileq,x)
		q.FilePath = self.Path	
		q.FileName = self.fileq.System_IO_FileInfo.FileName
		add(q)
	end

System_IO_Directory.CreateDirectory procedure(byte force=false)
	code
	if force
		self.RemoveDirectory()
	END
	CreateDirectory(self.Path)
	
	
System_IO_Directory.RemoveDirectory procedure(byte OnlyIfEmpty=false)	
shfop                                   LIKE(SHFILEOPgroup)
err                                     long
dirname                                 cstring(500)
	code
	!dbg.SetPrefix('System_IO_Directory.RemoveDirectory')
	if OnlyIfEmpty
		dbg.write('calling Clarion RemoveDirectory function')
		RemoveDirectory(self.Path)
	ELSE
		dirname = clip(self.Path) & '<0><0>' ! Needed for Win7 and maybe Vista
		CLEAR(shfop)
		shfop.wFunc  = FO_DELETE
		shfop.pFROM  = ADDRESS(dirname)
		shfop.fFlags = FOF_NOCONFIRMATION + FOF_NOCONFIRMMKDIR
		dbg.write('calling SHFileOperation to delete ' & self.Path)
		err = SHFileOperation(ADDRESS(shfop))
		dbg.write('return: ' & err)
	end
	
	
	
System_IO_Directory.Init    procedure(string dirname)
	CODE
	self.Path = dirname
	if self.Path[len(self.Path)] <> '\'
		self.Path = self.Path & '\'
	end
	self.RefreshNeeded = true
	
System_IO_Directory.SetFilesOnly    procedure(byte flag)
	CODE
	self.RefreshNeeded = true
	
System_IO_Directory.SetFilter       procedure(string filter)
	CODE
	self.RefreshNeeded = true
	self.filter = filter
	dbg.Write('Filter: ' & self.filter)

System_IO_Directory.SetMaxDaysOld   procedure(long maxDays)
	CODE
	self.MaxDaysOld = maxDays



	