#TEMPLATE(ClarionTest, 'Clarion unit testing'),FAMILY('ABC')
#!---------------------------------------------------------------------
#PROCEDURE(TestProcedure, 'Test Procedure (DO NOT USE - select Test Procedure from the Default tab, not from here)'), PARENT(Source(ABC))
#DEFAULT
NAME DefaultTestProcedure
GLOBAL
CATEGORY 'Test procedures'
PROTOTYPE '(*long addr),long,pascal'
[COMMON]
DESCRIPTION 'Test Procedure'
FROM ABC Source
[PROMPTS]
%Parameters DEFAULT  ('(*long addr)')
[ADDITION]
NAME ClarionTest TestSupport
[INSTANCE]
INSTANCE 1
[WINDOW]
Window WINDOW('dummy ')
     END
#ENDDEFAULT
#!---------------------------------------------------------------------
#! Add necessary vars to support testing protocols
#!---------------------------------------------------------------------
#Extension(TestSupport,'Support testing protocol'),PROCEDURE
#Prepare
    #Insert(%Debug,'TestSupport PREPARE for procedure ' & %Procedure)
    #Insert(%ValidateTestProcParameters,%AddressVar)
#EndPrepare    
#Prompt('Address var',@s50),%AddressVar,Default('lpTestResults')
#PROMPT('Test Code)',EDIT),%TestCode
#AtStart
    #Insert(%Debug,'TestSupport ATSTART for procedure ' & %Procedure)
    #Insert(%ValidateTestProcParameters,%AddressVar)
    #Add(%TestProcedures,%Procedure)
#EndAt    
#At(%DataSection)
#Insert(%Debug,'TestSupport, generating data')
#EndAt
#At(%ProcessedCode),first
    %AddressVar = address(UnitTestResult)
    BeginUnitTest('%Procedure')
    !-------------------------------------------------------------------
    ! Write your code to test for a result, using the AssertThat syntax.
    ! At present there are two different assertions you can use, IsEqualto
    ! and IsNotEqualTo. You can pass in any data type that Clarion can
    ! automatically convert to a string. 
    ! 
    ! 	AssertThat('a',IsEqualTo('a'),'this is an optional extra message')
    !	AssertThat(1,IsNotEqualTo(2))
    !
    ! As soon as an Assert statement fails there remaining tests will
    ! not be executed. 
    !-------------------------------------------------------------------
    %TestCode
#EndAt
#At(%ProcessedCode),last
    return 0
#EndAt    
#!---------------------------------------------------------------------
#Extension(TestSupportIncludes,'Add global includes for test support'),APPLICATION
#PROMPT('Test procedures',@S200),%TestProcedures,MULTI('Procedure names')
#At(%GlobalData)
	include('ClarionTest_GlobalCodeAndData.inc','GlobalData'),once
ClarionTest_ctpl 			ClarionTest_Procedures
#EndAt
#At(%GlobalMap)
	include('ClarionTest_GlobalCodeAndData.inc','GlobalMap'),once
#EndAt
#At(%ProgramProcedures),priority(1)
	include('ClarionTest_GlobalCodeAndData.inc','ProgramProcedures'),once
#EndAt
#At(%ProcedureDeclarationsInsideGlobalMap)
ClarionTest_GetListOfTestProcedures	procedure(*long addr),long,pascal
#EndAt
#At(%DllExportList)
	CLARIONTEST_GETLISTOFTESTPROCEDURES  @?
#EndAt
#At(%ProgramProcedures),priority(1000)
ClarionTest_GetListOfTestProcedures	procedure(*long addr)
	code
	addr = address(ClarionTest_ctpl)
	free(ClarionTest_ctpl.List)
	#FOR(%Procedure)
		#FIX(%TestProcedures,%Procedure)
		#If(%TestProcedures)
	ClarionTest_ctpl.List.testname = '%Procedure' ! %ProcedureCategory
	add(ClarionTest_ctpl.List,ClarionTest_ctpl.List.testname)
		#EndIf
	#EndFor
	return true
	
#EndAt
#!---------------------------------------------------------------------
#! The following code could probably be handled nicely with a couple of
#! RegEx expressions - anybody want to tackle that?
#!---------------------------------------------------------------------
#Group(%ValidateTestProcParameters,* %AddressVar)
#Declare(%StartPos)
#Declare(%EndPos)
#Declare(%Param1)
#Declare(%Param1Type)
#Declare(%RetType)
#Insert(%Trace,'ValidateTestProcParameters')
#! Make sure the procedure name begins with TEST_
#Insert(%Trace,'ValidateTestProcParameters - checking procedure name ' & %Procedure)
#! #If( len(%Procedure) < 6 or lower(sub(%Procedure,1,5)) <> 'test_')
#!     #Error('Procedure "' & %Procedure & '" is misnamed. Test procedure names must begin with Test_')
#!     #! #Abort
#! #EndIf    
#! Make sure there's a (
#Insert(%Trace,'ValidateTestProcParameters - checking for (')
#Set(%StartPos,instring('(',%Prototype,1,1))
#If(%StartPos = 0)
    #Insert(%ValidateTestProcParametersCriticalError)
    #Return
#EndIf    
#Set(%StartPos,%StartPos+1)
#! Get the contents inside the ()
#Insert(%Trace,'ValidateTestProcParameters, getting parameters')
#Set(%EndPos,instring(')',%Prototype,1,1))
#If(%EndPos = 0 or %EndPos =< %StartPos)
    #Insert(%ValidateTestProcParametersCriticalError)
    #Return
#EndIf    
#Set(%Param1,sub(%Prototype,%StartPos,%EndPos - %StartPos))
#Insert(%Debug,'TempParam: ' & %Param1)
#! #! Make sure there's no , - i.e. only one parameter
#Insert(%Trace,'ValidateTestProcParameters - making sure there''s only one parameter')
#Insert(%Debug,'TempParam: ' & %Param1)
#Set(%StartPos,instring(',',%Param1,1,1))
#If(%StartPos > 0)
    #Insert(%ValidateTestProcParametersCriticalError)
    #Return
#EndIf
#! Get the type and the label
#Insert(%Trace,'ValidateTestProcParameters - verifying both type and name are present')
#Set(%StartPos,instring(' ',%Param1,1,1))
#If(%StartPos = 0)
    #Insert(%ValidateTestProcParametersCriticalError)
    #Return
#EndIf
#Insert(%Trace,'ValidateTestProcParameters - verifying the type is *long')
#Set(%Param1Type,sub(%Param1,1,%StartPos-1))
#Insert(%Debug,'Type is ' & upper(%Param1Type))
#If(lower(%Param1Type) <> '*long')
    #Insert(%ValidateTestProcParametersCriticalError)
    #Return
#EndIf
#Set(%AddressVar,sub(%Param1,%StartPos+1,%len(%Param1)-%StartPos))
#Insert(%Debug,'Set addressvar to ' & %AddressVar)
#! Make sure there's a return type of long
#Set(%RetType,lower(sub(%Prototype,%EndPos+1,len(%Prototype)-%EndPos)))
#Insert(%Debug,'Set RetType to ' & %RetType)
#If(instring(',long',%RetType,1,1) > 0 and instring(',pascal',%RetType,1,1) > 0)
    #Insert(%Debug,'both ,long and ,pascal found')
#Else
    #Insert(%Debug,',long and ,pascal NOT both found')
    #Insert(%ValidateTestProcParametersCriticalError)
    #Return
#EndIf
#!---------------------------------------------------------------------
#Group(%ValidateTestProcParametersCriticalError)
#Error('The procedure ' & %Procedure & ' must have a prototype of (*long AnyVariableNameHere),long,pascal')
#! #Abort
#!-----------------------------------------------------------------------------
#Group(%Trace,%Msg)
#! #Message(%Msg,2)
#! #RUNDLL('TplDebug.DLL','ODS',%Msg),WIN32
#!-----------------------------------------------------------------------------
#Group(%Debug,%Msg)
#! #Message('*** ' & %Msg,2)
#!-----------------------------------------------------------------------------
#! #RUNDLL('TplDebug.DLL','ODS','[dbg] ' & %Msg),WIN32
#!-----------------------------------------------------------------------------
